> ## Documentation Index
> Fetch the complete documentation index at: https://seam-feat-mintlify-migration-iteration.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Get an Event

> Returns a specified event. This endpoint returns the same event that would be sent to a [webhook](/developer-tools/webhooks), but it enables you to retrieve an event that already took place.



## OpenAPI

````yaml /openapi.json post /events/get
openapi: 3.0.0
info:
  title: Seam Connect
  version: 1.0.0
servers:
  - url: https://connect.getseam.com
security: []
tags:
  - description: access_codes
    name: /access_codes
  - description: acs
    name: /acs
  - description: action_attempts
    name: /action_attempts
  - description: client_sessions
    name: /client_sessions
  - description: connected_accounts
    name: /connected_accounts
  - description: connect_webviews
    name: /connect_webviews
  - description: devices
    name: /devices
  - description: events
    name: /events
  - description: health
    name: /health
  - description: locks
    name: /locks
  - description: networks
    name: /networks
  - description: noise_sensors
    name: /noise_sensors
  - description: phones
    name: /phones
  - description: thermostats
    name: /thermostats
  - description: user_identities
    name: /user_identities
  - description: webhooks
    name: /webhooks
  - description: workspaces
    name: /workspaces
paths:
  /events/get:
    post:
      tags:
        - /events
      summary: Get an Event
      description: >-
        Returns a specified event. This endpoint returns the same event that
        would be sent to a [webhook](/developer-tools/webhooks), but it enables
        you to retrieve an event that already took place.
      operationId: eventsGetPost
      requestBody:
        content:
          application/json:
            schema:
              properties:
                device_id:
                  description: >-
                    Unique identifier for the device that triggered the event
                    that you want to get.
                  format: uuid
                  type: string
                event_id:
                  description: Unique identifier for the event that you want to get.
                  format: uuid
                  type: string
                event_type:
                  description: Type of the event that you want to get.
                  type: string
              type: object
      responses:
        '200':
          content:
            application/json:
              schema:
                properties:
                  event:
                    $ref: '#/components/schemas/event'
                  message:
                    type: string
                  ok:
                    type: boolean
                required:
                  - ok
                type: object
          description: OK
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
      security:
        - client_session: []
        - api_key: []
        - pat_with_workspace: []
        - console_session_with_workspace: []
        - client_session_with_customer: []
      x-codeSamples:
        - lang: javascript
          label: Seam SDK
          source: >-
            await seam.events.get({ event_id:
            "ed3adbb8-bbe1-4033-a35a-710d44322bd8" });


            /*

            {
              "connected_account_id": "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
              "created_at": "2025-06-15T16:54:18.000000Z",
              "device_id": "3febfdb2-de92-43c1-aba4-640ce8a55a22",
              "event_description": "The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
              "event_id": "ed3adbb8-bbe1-4033-a35a-710d44322bd8",
              "event_type": "device.connected",
              "occurred_at": "2025-06-15T16:54:17.946329Z",
              "workspace_id": "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d"
            }

            */
        - lang: bash
          label: cURL
          source: >-
            curl --include --request POST
            "https://connect.getseam.com/events/get" \
              --header "Authorization: Bearer $SEAM_API_KEY" \
              --json @- <<EOF
            {
              "event_id": "ed3adbb8-bbe1-4033-a35a-710d44322bd8"
            }

            EOF


            # Response:

            # {

            #   "event": {

            #     "connected_account_id":
            "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",

            #     "created_at": "2025-06-15T16:54:18.000000Z",

            #     "device_id": "3febfdb2-de92-43c1-aba4-640ce8a55a22",

            #     "event_description": "The status of a device changed from
            offline to online. That is, the device.properties.online property
            changed from false to true. Note that some devices operate entirely
            in offline mode, so Seam never emits a device.connected event for
            these devices.",

            #     "event_id": "ed3adbb8-bbe1-4033-a35a-710d44322bd8",

            #     "event_type": "device.connected",

            #     "occurred_at": "2025-06-15T16:54:17.946329Z",

            #     "workspace_id": "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d"

            #   }

            # }
        - lang: python
          label: Seam SDK
          source: |-
            seam.events.get(event_id="ed3adbb8-bbe1-4033-a35a-710d44322bd8")

            # SeamEvent(
                connected_account_id="2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
                created_at="2025-06-15T16:54:18.000000Z",
                device_id="3febfdb2-de92-43c1-aba4-640ce8a55a22",
                event_description="The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
                event_id="ed3adbb8-bbe1-4033-a35a-710d44322bd8",
                event_type="device.connected",
                occurred_at="2025-06-15T16:54:17.946329Z",
                workspace_id="9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d",
            )
        - lang: ruby
          label: Seam SDK
          source: |-
            seam.events.get(event_id: "ed3adbb8-bbe1-4033-a35a-710d44322bd8")

            # => {
              "connected_account_id" => "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
              "created_at" => "2025-06-15T16:54:18.000000Z",
              "device_id" => "3febfdb2-de92-43c1-aba4-640ce8a55a22",
              "event_description" =>
                "The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
              "event_id" => "ed3adbb8-bbe1-4033-a35a-710d44322bd8",
              "event_type" => "device.connected",
              "occurred_at" => "2025-06-15T16:54:17.946329Z",
              "workspace_id" => "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d",
            }
        - lang: php
          label: Seam SDK
          source: >-
            $seam->events->get(event_id:
            "ed3adbb8-bbe1-4033-a35a-710d44322bd8");


            // [
                "connected_account_id" => "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",
                "created_at" => "2025-06-15T16:54:18.000000Z",
                "device_id" => "3febfdb2-de92-43c1-aba4-640ce8a55a22",
                "event_description" =>
                    "The status of a device changed from offline to online. That is, the device.properties.online property changed from false to true. Note that some devices operate entirely in offline mode, so Seam never emits a device.connected event for these devices.",
                "event_id" => "ed3adbb8-bbe1-4033-a35a-710d44322bd8",
                "event_type" => "device.connected",
                "occurred_at" => "2025-06-15T16:54:17.946329Z",
                "workspace_id" => "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d",
            ];
        - lang: bash
          label: Seam CLI
          source: >-
            seam events get --event_id "ed3adbb8-bbe1-4033-a35a-710d44322bd8"


            # {

            #   "connected_account_id": "2e3f4a5b-6c7d-8e9f-0a1b-2c3d4e5f6a7b",

            #   "created_at": "2025-06-15T16:54:18.000000Z",

            #   "device_id": "3febfdb2-de92-43c1-aba4-640ce8a55a22",

            #   "event_description": "The status of a device changed from
            offline to online. That is, the device.properties.online property
            changed from false to true. Note that some devices operate entirely
            in offline mode, so Seam never emits a device.connected event for
            these devices.",

            #   "event_id": "ed3adbb8-bbe1-4033-a35a-710d44322bd8",

            #   "event_type": "device.connected",

            #   "occurred_at": "2025-06-15T16:54:17.946329Z",

            #   "workspace_id": "9a8b7c6d-5e4f-3a2b-1c0d-9e8f7a6b5c4d"

            # }
components:
  schemas:
    event:
      description: >-
        Represents an event. Events let you know when something interesting
        happens in your workspace. For example, when a lock is unlocked, Seam
        creates a `lock.unlocked` event. When a device's battery level is low,
        Seam creates a `device.battery_low` event.
      discriminator:
        propertyName: event_type
      oneOf:
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            created.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.created
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            changed.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.changed
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            [scheduled
            natively](/low-level-apis/smart-locks/access-codes#native-scheduling)
            on a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            code:
              description: Code for the affected access code.
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.scheduled_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - code
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was set
            on a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            code:
              description: Code for the affected access code.
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.set_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - code
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            removed from a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.removed_from_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            There was an unusually long delay in setting an [access
            code](/low-level-apis/smart-locks/access-codes) on a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.delay_in_setting_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) failed to
            be set on a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.failed_to_set_on_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            deleted.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            code:
              description: Code for the affected access code.
              nullable: true
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.deleted
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - code
          type: object
          x-route-path: /access_codes
        - description: >-
            There was an unusually long delay in removing an [access
            code](/low-level-apis/smart-locks/access-codes) from a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.delay_in_removing_from_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) failed to
            be removed from a device.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.failed_to_remove_from_device
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            modified outside of Seam.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.modified_external_to_seam
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            An [access code](/low-level-apis/smart-locks/access-codes) was
            deleted outside of Seam.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.deleted_external_to_seam
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes
        - description: >-
            A [backup access
            code](/low-level-apis/smart-locks/access-codes/backup-access-codes)
            was pulled from the backup access code pool and set on a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            backup_access_code_id:
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.backup_access_code_pulled
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - backup_access_code_id
          type: object
          x-route-path: /access_codes
        - description: >-
            An [unmanaged access
            code](/low-level-apis/smart-locks/access-codes/migrating-existing-access-codes)
            was converted successfully to a managed access code.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.unmanaged.converted_to_managed
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes/unmanaged
        - description: >-
            An [unmanaged access
            code](/low-level-apis/smart-locks/access-codes/migrating-existing-access-codes)
            failed to be converted to a managed access code.
          properties:
            access_code_errors:
              description: Errors associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            access_code_warnings:
              description: Warnings associated with the access code.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_errors:
              description: Errors associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            connected_account_warnings:
              description: Warnings associated with the connected account.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_errors:
              description: Errors associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the error.
                    format: date-time
                    type: string
                  error_code:
                    description: >-
                      Unique identifier of the type of error. Enables quick
                      recognition and categorization of the issue.
                    type: string
                  message:
                    description: >-
                      Detailed description of the error. Provides insights into
                      the issue and potentially how to rectify it.
                    type: string
                required:
                  - created_at
                  - message
                  - error_code
                type: object
              type: array
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            device_warnings:
              description: Warnings associated with the device.
              items:
                properties:
                  created_at:
                    description: Date and time at which Seam created the warning.
                    format: date-time
                    type: string
                  message:
                    description: >-
                      Detailed description of the warning. Provides insights
                      into the issue and potentially how to rectify it.
                    type: string
                  warning_code:
                    description: >-
                      Unique identifier of the type of warning. Enables quick
                      recognition and categorization of the issue.
                    type: string
                required:
                  - created_at
                  - message
                  - warning_code
                type: object
              type: array
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.unmanaged.failed_to_convert_to_managed
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
            - connected_account_errors
            - connected_account_warnings
            - device_errors
            - device_warnings
            - access_code_errors
            - access_code_warnings
          type: object
          x-route-path: /access_codes/unmanaged
        - description: >-
            An [unmanaged access
            code](/low-level-apis/smart-locks/access-codes/migrating-existing-access-codes)
            was created on a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.unmanaged.created
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes/unmanaged
        - description: >-
            An [unmanaged access
            code](/low-level-apis/smart-locks/access-codes/migrating-existing-access-codes)
            was removed from a device.
          properties:
            access_code_id:
              description: ID of the affected access code.
              format: uuid
              type: string
            connected_account_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the connected account, present when
                connected_account_id is provided.
              type: object
            connected_account_id:
              description: >-
                ID of the [connected account](/core-concepts/connected-accounts)
                associated with the affected access code.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            device_custom_metadata:
              additionalProperties:
                oneOf:
                  - type: string
                  - type: boolean
              description: >-
                Custom metadata of the device, present when device_id is
                provided.
              type: object
            device_id:
              description: ID of the device associated with the affected access code.
              format: uuid
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_code.unmanaged.removed
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_code_id
            - device_id
            - connected_account_id
            - event_type
          type: object
          x-route-path: /access_codes/unmanaged
        - description: An Access Grant was created.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.created
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
          type: object
          x-route-path: /access_grants
        - description: An Access Grant was deleted.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.deleted
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
          type: object
          x-route-path: /access_grants
        - description: All access requested for an Access Grant was successfully granted.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.access_granted_to_all_doors
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
          type: object
          x-route-path: /access_grants
        - description: >-
            Access requested as part of an Access Grant to a particular door was
            successfully granted.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            acs_entrance_id:
              description: >-
                ID of the affected
                [entrance](/low-level-apis/access-systems/retrieving-entrance-details).
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.access_granted_to_door
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
            - acs_entrance_id
          type: object
          x-route-path: /access_grants
        - description: >-
            Access to a particular door that was requested as part of an Access
            Grant was lost.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            acs_entrance_id:
              description: >-
                ID of the affected
                [entrance](/low-level-apis/access-systems/retrieving-entrance-details).
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.access_to_door_lost
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
            - acs_entrance_id
          type: object
          x-route-path: /access_grants
        - description: An Access Grant's start or end time was changed.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            access_grant_key:
              description: Key of the affected Access Grant (if present).
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            ends_at:
              description: The new end time for the access grant.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.access_times_changed
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            starts_at:
              description: The new start time for the access grant.
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
          type: object
          x-route-path: /access_grants
        - description: >-
            One or more requested access methods could not be created for an
            Access Grant.
          properties:
            access_grant_id:
              description: ID of the affected Access Grant.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            error_message:
              description: Description of why the access methods could not be created.
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_grant.could_not_create_requested_access_methods
              type: string
            missing_device_ids:
              description: >-
                IDs of the devices that did not receive a requested access
                method. Use these to identify which specific devices failed
                without having to fetch the Access Grant.
              items:
                format: uuid
                type: string
              type: array
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_grant_id
            - event_type
            - error_message
          type: object
          x-route-path: /access_grants
        - description: An access method was issued.
          properties:
            access_grant_ids:
              description: IDs of the access grants associated with this access method.
              items:
                format: uuid
                type: string
              type: array
            access_grant_keys:
              description: >-
                Keys of the access grants associated with this access method (if
                present).
              items:
                type: string
              type: array
            access_method_id:
              description: ID of the affected access method.
              format: uuid
              type: string
            code:
              description: >-
                The actual PIN code for code access methods (only present when
                mode is 'code').
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_method.issued
              type: string
            is_backup_code:
              description: >-
                Indicates whether the code is a backup code (only present when
                mode is 'code' and a backup code was used).
              type: boolean
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_method_id
            - access_grant_ids
            - event_type
          type: object
          x-route-path: /access_methods
        - description: An access method was revoked.
          properties:
            access_grant_ids:
              description: IDs of the access grants associated with this access method.
              items:
                format: uuid
                type: string
              type: array
            access_grant_keys:
              description: >-
                Keys of the access grants associated with this access method (if
                present).
              items:
                type: string
              type: array
            access_method_id:
              description: ID of the affected access method.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_method.revoked
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_method_id
            - access_grant_ids
            - event_type
          type: object
          x-route-path: /access_methods
        - description: An access method representing a physical card requires encoding.
          properties:
            access_grant_ids:
              description: IDs of the access grants associated with this access method.
              items:
                format: uuid
                type: string
              type: array
            access_grant_keys:
              description: >-
                Keys of the access grants associated with this access method (if
                present).
              items:
                type: string
              type: array
            access_method_id:
              description: ID of the affected access method.
              format: uuid
              type: string
            created_at:
              description: Date and time at which the event was created.
              format: date-time
              type: string
            event_id:
              description: ID of the event.
              format: uuid
              type: string
            event_type:
              enum:
                - access_method.card_encoding_required
              type: string
            occurred_at:
              description: Date and time at which the event occurred.
              format: date-time
              type: string
            workspace_id:
              description: >-
                ID of the [workspace](/core-concepts/workspaces) associated with
                the event.
              format: uuid
              type: string
          required:
            - event_id
            - workspace_id
            - created_at
            - occurred_at
            - access_method_id
            - access_grant_ids
            - event_type
          type: object
          x-route-path: /access_methods
        - description: An access method was deleted.
          properties:
            access_grant_ids:
              description: IDs of the access grants associated with this access method.
              items:
                format: uuid
                type: string
              type: array
            access_grant_keys:
              description: >-
                Keys of the access grants associated with this access method (if
                present).
              items:
                type: string
              type: array
            access_method_id:
              description: ID of the affected access method.
              format: uuid
              type: string
            created_at:
[...]
